@mixin die-icons {
	.roll {
		&.die {
			&.d20 {
				background-image: url(../../icons/svg/d20-grey.svg);
			}

			&.d12 {
				background-image: url(../../icons/svg/d12-grey.svg);
			}

			&.d10 {
				background-image: url(../../icons/svg/d10-grey.svg);
			}

			&.d8 {
				background-image: url(../../icons/svg/d8-grey.svg);
			}

			&:is(.d6, .weird-die) {
				background-image: url(../../icons/svg/d6-grey.svg);
			}

			&.d4 {
				background-image: url(../../icons/svg/d4-grey.svg);
			}
		}
	}
}

@mixin die-style {
	.roll {
		place-self: center;

		&:is(.die, .fatedie, .coin) {
			background-size: cover;
			width: 1.25em;
			height: 1.25em;
			display: inline-block;
			background-image: url(../../icons/svg/d6-grey.svg);
			background-position-y: center;
			background-repeat: no-repeat;
		}
	}
}

.chat-message[data-message-id] {
	:is(.chat-attack, .dice-roll) {
		.dice-tooltip {
			.lil-formula {
				text-align: center;
				justify-content: center;
				font-weight: normal;

				&.lil-lots-of-terms {
					font-size: var(--font-size-14);
				}
			}
		}

		:is(
				.lil-expanded-normal-inline-roll,
				.lil-expanded-inline-roll,
				.lil-enhanced-roll,
				.lil-roll
			) {
			display: inline-flex;
			gap: 1px;
		}

		/*
		.lil-expanded-inline-roll,
		.lil-enhanced-roll,
		.lil-roll {
			*/

		.lil-roll-restyle {
			@include die-style;
			@include die-icons;

			.roll {
				// Ensure d20 => total has die in smaller size
				font-size: var(--font-size-16);
			}
		}

		//}

		// Inline roll
		a.inline-roll.inline-result {
			&.lil-roll-restyle {
				border-color: #6e91b3;
				background-color: #e7e8e7;

				&.expanded:not(.failure):not(.success) {
					background-color: #c9e4e6;
					border-color: #427ade;
				}

				&.natural-1,
				&.failure {
					background-color: #cc9489;
					border-color: #8e3b21;

					&.expanded {
						background-color: #e67a5d;
						border-color: #980000;
					}
				}

				&.natural-20,
				&.success {
					background-color: #80cc80;
					border-color: #3c8610;

					&.expanded {
						background-color: #3fda3f;
						border-color: #07610a;
					}
				}

				&.critical-threat:not(.natural-20) {
					background-color: #e1c997;
					border-color: #c78e25;
				}

				&.natural-20 {
				}
			}
		}

		.lil-enhanced-roll {
			border-radius: 3px;
			display: flex;
			gap: 0.15em;
			justify-content: center;
		}

		&:not(.success):not(.failure) {
			.lil-roll {
				filter: unset;
			}
		}

		.lil-roll {
			.roll {
				&:is(.coin, .fatedie, .die) {
					filter: sepia(0.3) contrast(1.1) brightness(1.2);

					&.rerolled {
						// Hide inactive dice
						display: none;
					}
				}
			}
		}

		.lil-roll-restyle.enlarged-die .roll:is(.die, .fatedie, .coin) {
			font-size: var(--font-size-18);
		}

		.lil-enhanced-tooltip.dice-tooltip .dice-rolls {
			.roll {
				&.coin,
				&.fatedie,
				&.die {
					filter: sepia(0.3) contrast(1.1) brightness(1.1);
				}
			}
		}

		.lil-roll,
		.lil-enhanced-tooltip.dice-tooltip .dice-rolls {
			filter: contrast(1.1) brightness(1.1);
			font-size: var(--font-size-18);
			font-weight: bold;

			.roll {
				&.coin,
				&.fatedie,
				&.die {
					&.heads,
					&.max,
					&.success {
						/*filter: hue-rotate(148deg);*/
						//color: #006891;
						color: #003dea;
						text-shadow: 7px #00ffd49c;
					}

					&.tails,
					&.min,
					&.failure {
						/*filter: hue-rotate(-3deg);*/
						//color: #984242;
						color: #b70a0a;
						text-shadow: 7px #ff6e00ed;
					}

					&.rerolled {
						color: gray;
					}
				}

				&.discarded {
					opacity: 0.4;
				}
			}
		}

		.lil-enhanced-tooltip {
			> .lil-formula {
				font-size: var(--font-size-11);
			}
		}

		.lil-bonus {
			font-weight: normal;
			//vertical-align: top;
			font-size: var(--font-size-12);
			//line-height: 1.6em;
		}

		.lil-total {
			//text-shadow: 3px antiquewhite;
		}

		.lil-arrow {
			// padding: 0 0.2em;
		}

		.inline-roll .lil-arrow {
			line-height: 1;
		}
	}

	.dice-roll .lil-combined-result {
		font-size: var(--font-size-16);

		.dice-total {
			display: flex;
			gap: 3px;
			justify-content: center;
			//place-items: center;

			line-height: 1.3; // 1.15em;

			flex: 1;
			gap: 3px;
		}

		.lil-formula {
			font-size: var(--font-size-16);
			place-self: center;
		}

		:is(.lil-roll, .lil-bonus, .lil-total) {
			white-space: nowrap;
		}

		.lil-roll {
			place-self: center;
		}

		.lil-bonus {
			font-size: var(--font-size-11);
		}

		.lil-arrow,
		.lil-total {
			font-size: var(--font-size-18);
		}
	}

	.lil-expanded-inline-roll {
		padding: 0;
		display: flex;
		margin: 0 3px;
		font-size: var(--font-size-18);

		width: 100%; // Fix for sizing issue coming from somewhere

		border-radius: 3px;
		gap: 0.15em;
		justify-content: center;
		place-self: center;

		&:hover {
			text-shadow: 3px #ff7a00;
		}

		.roll {
			filter: sepia(0.3) contrast(1.2);
			font-family: var(--font-primary);
			font-weight: bold;

			&.discarded {
				filter: sepia(0.3) contrast(1.2) opacity(0.4);
			}
		}

		@include die-style;
		@include die-icons;

		> .lil-roll {
			font-size: var(--font-size-18);
			display: inline-block;
		}

		> .lil-bonus {
			vertical-align: super;
			font-size: var(--font-size-11);
		}

		> .lil-total {
			font-weight: bold;
			font-size: var(--font-size-18);
		}

		&:not(.success):not(.failure) i {
			color: rgba(0, 0, 0, 0.25);
			text-shadow: 3px white;
		}
	}
}
